package model;

import java.util.ArrayList;

public class Kamikaze extends Knight { // aka Trojan knight :P
    public Kamikaze(Position p, int color) {
        super(p, color);
    }

    // getAvailableMoves is in Knight already

    public ArrayList<Position> getExplosion() {

        ArrayList<Position> moves = new ArrayList<>();
        Position target;

        for(int x = -1 ; x <= 1 ; x++) {
            for(int y = -1 ; y <= 1 ; y++) {
                target = new Position(p.getX() + x, p.getY() + y);
                if (target.isCorrect()) {
                    moves.add(target);
                }
            }
        }
        return moves;
    }

    public Piece newInstanceCopy() {
        return new Kamikaze(p, color);
    }
}
