package model;

import java.util.ArrayList;

public class Nwap extends Pawn {

    private boolean enPassant;
    public Nwap(Position p, int color) {
        super(p, color);
        enPassant = false;
    }

    @Override
    public ArrayList<Position> getAvailableMoves(Board b) {

        ArrayList<Position> moves = new ArrayList<>();
        Position arrival;
        Position arrival2;

        if(color == Piece.WHITE) { // black and white have an opposite direction behavior

            // up left
            arrival = new Position(p.getX()-1, p.getY() +1);
            if(arrival.isCorrect() && b.isFree(arrival)) {
                moves.add(arrival);
                if(!hasBeenMoved) {
                    arrival2 = new Position(p.getX() - 2, p.getY() + 2);
                    if (arrival2.isCorrect() && b.isFree(arrival2)) {
                        moves.add(arrival2);
                    }
                }
            }

            // up right
            arrival = new Position(p.getX()+1, p.getY() +1);
            if(arrival.isCorrect() && b.isFree(arrival)) {
                moves.add(arrival);
                if (!hasBeenMoved) {
                    arrival2 = new Position(p.getX() + 2, p.getY() + 2);
                    if (arrival2.isCorrect() && b.isFree(arrival2)) {
                        moves.add(arrival2);
                    }
                }
            }

            // up attack
            arrival = new Position(p.getX(),p.getY()+1);
            if(b.isEnemy(arrival,p)) {moves.add(arrival);}
        }
        else {

            // down left
            arrival = new Position(p.getX()-1, p.getY() -1);
            if(arrival.isCorrect() && b.isFree(arrival)) {
                moves.add(arrival);
                if (!hasBeenMoved) {
                    arrival2 = new Position(p.getX() - 2, p.getY() - 2);
                    if (arrival2.isCorrect() && b.isFree(arrival2)) {
                        moves.add(arrival2);
                    }
                }
            }

            // down right
            arrival = new Position(p.getX()+1, p.getY() -1);
            if(arrival.isCorrect() && b.isFree(arrival)) {
                moves.add(arrival);
                if (!hasBeenMoved) {
                    arrival2 = new Position(p.getX() + 2, p.getY() - 2);
                    if (arrival2.isCorrect() && b.isFree(arrival2)) {
                        moves.add(arrival2);
                    }
                }
            }

            // down attack
            arrival = new Position(p.getX(),p.getY()-1);
            if(b.isEnemy(arrival,p)) {moves.add(arrival);}
        }
        return moves;
    }
    public boolean isEnPassant() {
        return enPassant;
    }

    public void setEnPassant(boolean enPassant) {
        this.enPassant = enPassant;
    }

    public Piece newInstanceCopy() {
        Nwap nwap = new Nwap(p, color);
        nwap.setEnPassant(enPassant);
        nwap.setHasBeenMoved(hasBeenMoved);
        return nwap;
    }
}
